<?php
$json = json_decode(file_get_contents('dns-packets.json'),true);

$state = 'nothing';
$filename = '';
$accumulator = '';
$previousDns = null;
$previousTime = 0;
foreach ($json as $js) {
	$query = $js['_source']['layers']['dns']['Queries'];
	if (count($query) !== 1)
		throw new DomainException("Query with multiple entries");
	
	if (array_key_exists('Answers',$js['_source']['layers']['dns'])) {	
		$responseTo = reset(
		$js['_source']['layers']['dns']['Answers'])['dns.resp.name'];
		if ($previousDns !== $responseTo)
			throw new DomainException(
			"DNS response, but no request for $responseTo");
		continue; // Ignore answers
	}
		
	reset($query);
	
	$domain = current($query)['dns.qry.name'];
	$previousDns = $domain;
	$data = substr($domain, 0,
		strlen($domain)-strlen('.hallebarde.404ctf.fr'));
	
	if ($state === 'nothing') {
		if ($data !== 'never-gonna-give-you-up')
			throw new DomainException(
			"Invalid domain for nothing state: $data");
		$state = 'filename';
		$accumulator = '';
		continue;
	}
	
	$decoded = '';
	foreach (str_split($data,2) as $d) {
		$decoded .= chr(hexdec($d));
	}

	// J'essaie de voir quelles trames auraient disparu...
	$time = $js['_source']['layers']['frame']['frame.time_relative'];
	$deltaT = round($time - $previousTime,2);
	if ($deltaT > 0.2 && $deltaT < 50)
		echo "DeltaT:\t$deltaT\t$decoded\n";
	$previousTime = $time;
//	echo "$time:\t$deltaT;\t$decoded\n";

	switch ($state) {
		case 'filename':
			if ($decoded === 'begin') {
				echo "File: $accumulator\n";
				$filename = $accumulator;
				$accumulator = '';
				$state = 'data';
			} else {
				$accumulator .= $decoded;
			}
			break;
		case 'data':
			if ($decoded === 'end') {
				echo "Content retrieved\n";
				file_put_contents("data/$filename",$accumulator);
				$accumulator = '';
				$state = 'nothing';
			} else {
				$accumulator .= $decoded;
			}
			break;
	}
}

# 404CTF{exfiltration.py,flag.txt,hallebarde.png,super-secret.pdf}


